# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define reltag .redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

Name:           ecj3
Version:        3.7.2
Release:        6%{?reltag}%{?dist}
Epoch:          1
Summary:        Eclipse Compiler for Java
Group:          Development/Java
License:        EPL
URL:            http://www.eclipse.org/
Source0:        http://mirrors.ibiblio.org/pub/mirrors/eclipse/eclipse/downloads/drops/R-3.7.2-201202080800/ecjsrc-3.7.2.jar
Source1:        http://central.maven.org/maven2/org/eclipse/jdt/core/compiler/ecj/3.7.2/ecj-3.7.2.pom
Patch0:         ecj-vman.patch
%if 0
1:ecj-3.4.2-6.el6.i686 from build has depsolving problems
  --> Missing Dependency: java-gcj-compat is needed by package 1:ecj-3.4.2-6.el6.i686 (build)
%endif
%if 0
Provides:       ecj = %{epoch}:%{version}-%{release}
Obsoletes:      ecj < %{epoch}:%{version}-%{release}
%endif
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
#
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-default-skin
BuildRequires:  maven-jxr-plugin
BuildRequires:  maven-pmd-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  surefire-junit4
BuildArch:      noarch
BuildRoot:      %{_tmppath}/ecj3-%{namedversion}-%{release}-root

%description
Eclipse Compiler for Java.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n ecj-%{namedversion} -c
%{__cp} -p %{SOURCE1} pom.xml
%patch0 -p1 -b .sav0

%{__mkdir_p} src/main/java
%{__mv} org src/main/java

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://`pwd`/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Denforcer.skip deploy
pushd maven2-brew
baddirs=`%{_bindir}/find -type d \( -name "[0-9]*" -and -not -name %{namedversion} \)`
for baddir in ${baddirs}; do
    badver=`/bin/basename ${baddir} | %{__sed} "s/\./\\\./g;"`
    %{__mv} ${baddir}/* `/bin/echo ${baddir} | %{__sed} "s/${badver}/%{namedversion}/g;"`/ && %{__rm} -r ${baddir}/
done
popd

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p maven2-brew/org/eclipse/jdt/core/compiler/ecj/%{namedversion}/ecj-%{namedversion}.jar %{buildroot}%{_javadir}/ecj3-%{namedversion}.jar
%{__cp} -p maven2-brew/org/eclipse/jdt/core/compiler/ecj/%{namedversion}/ecj-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/ecj3-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/org/eclipse/jdt/core/compiler/ecj/%{namedversion}/ecj-%{namedversion}-sources.jar %{buildroot}%{_javadir}/ecj3-%{namedversion}-sources.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/org/eclipse/jdt/core/compiler/ecj/%{namedversion}/ecj-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-ecj3.pom

# depmaps
%add_to_maven_depmap org.eclipse.jdt.core.compiler ecj %{namedversion} JPP ecj3
# FIXME: backwards compatible depmap (not added to repolib)
%add_to_maven_depmap org.eclipse.jdt core %{namedversion} JPP ecj3
[ %{name} = ecj3 ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/ecj3

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/ecj3-%{namedversion}.jar
%{_javadir}/ecj3.jar
%exclude %{_javadir}/ecj3-%{namedversion}-javadoc.jar
%exclude %{_javadir}/ecj3-javadoc.jar
%{_javadir}/ecj3-%{namedversion}-sources.jar
%{_javadir}/ecj3-sources.jar
%{_mavenpomdir}/JPP-ecj3.pom
%{_mavendepmapfragdir}/ecj3

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Mon Mar 11 2013  David Walluck <dwalluck@redhat.com> 1:3.7.2-6
- remove Obsoletes/Provides: ecj
- change name of all files in main package from ecj to ecj3

* Fri Mar 01 2013 David Walluck <dwalluck@redhat.com> 1:3.7.2-5
- update ant scope

* Fri Mar 01 2013 David Walluck <dwalluck@redhat.com> 1:3.7.2-4
- use maven to build
- build javadoc and sources jars

* Tue Feb 19 2013 David Walluck <dwalluck@redhat.com> 1:3.7.2-3
- change name to ecj to match upstream artifactId
- fix deploy URL
- add vman patch

* Fri Jul 13 2012 David Walluck <dwalluck@redhat.com> 1:3.7.2-2
- use upstream pom
- add new groupId and artifactId in maven depmap frag
- update Group

* Tue Jul 03 2012 Permaine Cheung <pcheung@redhat.com> 1:3.7.2-1
- Upgrade to 3.7.2
- Update groupId and artifactId

* Tue Mar 20 2012 Weinan Li <weli@redhat.com> 1:3.7.1-1.1
- Upgrade to 3.7.1

* Tue Aug 16 2011 David Walluck <dwalluck@redhat.com> 1:3.7-1.2
- Provides/Obsoletes: ecj due to depsolving problems

* Wed Aug 10 2011 David Walluck <dwalluck@redhat.com> 1:3.7-1.1
- rebuild to fix repolib

* Wed Jul 20 2011 David Walluck <dwalluck@redhat.com> 1:3.7-1
- 3.7
- add pom

* Mon Sep 20 2010 David Walluck <dwalluck@redhat.com> 1:3.6-2
- replace tabs with spaces

* Mon Sep 20 2010 David Walluck <dwalluck@redhat.com> 1:3.6-1
- 3.6
- fix GCJ support option
- remove unused files

* Fri May 14 2010 Martha Benitez <mbenitez@redhat.com> - 1:3.3.1.1-3.1.1
- rebuilt

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhat.com> 1:3.3.1.1-3.1.1
- Rebuild

* Thu Dec 04 2008 Permaine Cheung <pcheung@redhat.com> 1:3.3.1.1-3.1
- Add Provides: ecj-non-eclipse

* Sat Jun 28 2008 David Walluck <dwalluck@redhat.com> 1:3.3.1.1-3.jpp5
- bump Epoch to match Fedora

* Sun Jun 22 2008 David Walluck <dwalluck@redhat.com> 0:3.3.1.1-2.jpp5
- make some fixes for gcj support

* Fri Oct 26 2007 Jason Corley <jason.corley@gmail.com> - 0:3.3.1.1-1jpp
- update to 3.3.1.1

* Fri Mar 23 2007 Jason Corley <jason.corley@gmail.com> - 0:3.3-1jpp
- update to 3.3
- add R on java and BR on sed

* Fri Mar 23 2007 Jason Corley <jason.corley@gmail.com> - 0:3.2.2-3jpp
- remove jdtcore link

* Mon Mar 12 2007 Jason Corley <jason.corley@gmail.com> - 0:3.2.2-2jpp
- rename to just ecj
- add gcj compilation switches (Andrew Overholt)

* Fri Mar  2 2007 Jason Corley <jason.corley@gmail.com> - 0:3.2.2-1jpp
- first attempt at a noarch ecj only package
